import { Injector, OnDestroy, OnInit } from '@angular/core';
import { AbstractHeaderService } from './abstract-header-service';
import { HeaderType } from './models/header-type';
import { HeaderMode } from './models/header-mode';
import { HeaderSearchService } from '../search/header-search-service/header-search.service';
import { FormControl } from '@angular/forms';
import { TranslateService } from '@ngx-translate/core';
import { OverflowService } from './services/overflow.service';
import { Subscription } from 'rxjs';
import { CaseViewService } from "../view/case-view/service/case-view-service";
import { DataFieldPortalData } from "../data-fields/models/data-field-portal-data-injection-token";
import { MultichoiceField } from "../data-fields/multichoice-field/models/multichoice-field";
import { EnumerationField } from "../data-fields/enumeration-field/models/enumeration-field";
import * as i0 from "@angular/core";
export declare abstract class AbstractHeaderComponent implements OnInit, OnDestroy {
    protected _injector: Injector;
    protected _translate: TranslateService;
    protected _overflowService: OverflowService;
    protected _caseViewService: CaseViewService;
    protected _dataFieldPortalData: DataFieldPortalData<MultichoiceField | EnumerationField>;
    protected readonly DEFAULT_COLUMN_COUNT = 6;
    protected readonly DEFAULT_COLUMN_WIDTH = 220;
    protected readonly INPUT_DEBOUNCE_TIME = 600;
    type: HeaderType;
    hideHeaderMenu: boolean;
    showEditButton: boolean;
    showSortButton: boolean;
    showSearchButton: boolean;
    showTableSection: boolean;
    approval: boolean;
    headerService: AbstractHeaderService;
    protected _headerSearch: HeaderSearchService;
    readonly headerModeEnum: typeof HeaderMode;
    readonly headerTypeEnum: typeof HeaderType;
    overflowControl: FormControl;
    columnCountControl: FormControl;
    columnWidthControl: FormControl;
    canOverflow: boolean;
    subOverflowControl: Subscription;
    subColumnCountControl: Subscription;
    subColumnWidthControl: Subscription;
    protected _initHeaderCount: number;
    protected _initResponsiveHeaders: boolean;
    protected _approvalFormControl: FormControl;
    protected _changeValue: boolean;
    protected _subCases: Subscription;
    constructor(_injector: Injector, _translate: TranslateService, _overflowService: OverflowService, _caseViewService: CaseViewService, _dataFieldPortalData: DataFieldPortalData<MultichoiceField | EnumerationField>);
    set maxHeaderColumns(count: number);
    set responsiveHeaders(responsive: boolean);
    get approvalFormControl(): FormControl;
    changeHeadersMode(mode: HeaderMode, saveLastMode?: boolean): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    /**
     * Injects the correct {@link AbstractHeaderService} instance based on this component's type
     */
    protected resolveHeaderService(): void;
    /**
     * Sets the correct {@link AbstractHeaderService} instance to the {@link HeaderSearchService}
     */
    protected initializedHeaderSearch(): void;
    clickStop($event: any): void;
    getMinWidth(): string;
    confirmEditMode(): void;
    getErrorMessageWidth(): any;
    getErrorMessageCount(): any;
    buildErrorMessage(formControlRef: FormControl, minNumber: any): any;
    protected initializeFormControls(exist: boolean): void;
    protected initializeValueChanges(): void;
    indeterminate(): boolean;
    typeApproval(): "enumeration" | "multichoice";
    protected resolveApprovalDatafields(): void;
    protected resolveApprovalValue(): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<AbstractHeaderComponent, [null, null, { optional: true; }, { optional: true; }, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AbstractHeaderComponent, "ncc-abstract-header", never, { "type": "type"; "hideHeaderMenu": "hideHeaderMenu"; "showEditButton": "showEditButton"; "showSortButton": "showSortButton"; "showSearchButton": "showSearchButton"; "showTableSection": "showTableSection"; "approval": "approval"; "maxHeaderColumns": "maxHeaderColumns"; "responsiveHeaders": "responsiveHeaders"; }, {}, never, never>;
}
